Index: issm/branches/trunk-jpl-damage/src/m/kml/kmlnodeconnectivity.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/kml/kmlnodeconnectivity.m	(revision 12168)
+++ issm/branches/trunk-jpl-damage/src/m/kml/kmlnodeconnectivity.m	(revision 12168)
@@ -0,0 +1,58 @@
+%
+%  create a node connectivity table for the elements in the model.
+%
+%  [nodecon]=edgeadjacency(elem,nnodes,mxepg)
+%
+%  where the required input is:
+%    elem          (numeric, element connectivity array (elems x nodes))
+%
+%  and the required output is:
+%    nodecon       (numeric, node connectivity array (nnodes x mxepg+1))
+%
+%  the optional input is:
+%    nnodes        (numeric, number of nodes)
+%    mxepg         (numeric, max elements per node)
+%
+function [nodecon]=kmlnodeconnectivity(elem,nnodes,mxepg)
+
+if ~nargin
+    help kmlnodeconnectivity
+    return
+end
+
+if ~exist('nnodes','var') || isempty(nnodes)
+    nnodes=max(max(elem));
+end
+if ~exist('mxepg','var') || isempty(mxepg)
+    mxepg=25;
+end
+
+%%  create the node connectivity array
+
+nodecon=zeros(nnodes,mxepg+1);
+
+%  loop over the elements
+
+for i=1:size(elem,1)
+
+%  loop over the nodes for each element
+
+    for j=1:size(elem,2)
+        if elem(i,j)
+            nodecon(elem(i,j),nodecon(elem(i,j),end)+1)=i;
+            nodecon(elem(i,j),end)=nodecon(elem(i,j),end)+1;
+        end
+    end
+end
+
+%%  sort the node connectivity array
+
+%  loop over the nodes
+
+for i=1:size(nodecon,1)
+    if (nodecon(i,end) > 1)
+        nodecon(i,1:nodecon(i,end))=sort(nodecon(i,1:nodecon(i,end)));
+    end
+end
+
+end
Index: issm/branches/trunk-jpl-damage/src/m/model/AnalysisConfiguration.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/model/AnalysisConfiguration.m	(revision 12168)
+++ issm/branches/trunk-jpl-damage/src/m/model/AnalysisConfiguration.m	(revision 12168)
@@ -0,0 +1,58 @@
+function [analyses,numanalyses]=AnalysisConfiguration(solutiontype),
+%ANALYSISCONFIGURATION - return type of analyses, number of analyses 
+%
+%   Usage:
+%      [analyses, numanalyses]=AnalysisConfiguration(solutiontype);
+
+
+
+switch solutiontype,
+
+	case DiagnosticSolutionEnum,
+		numanalyses=5;
+		analyses=[DiagnosticHorizAnalysisEnum;DiagnosticVertAnalysisEnum;DiagnosticHutterAnalysisEnum;SurfaceSlopeAnalysisEnum;BedSlopeAnalysisEnum];
+
+	case SteadystateSolutionEnum,
+		numanalyses=7; 
+		analyses=[DiagnosticHorizAnalysisEnum;DiagnosticVertAnalysisEnum;DiagnosticHutterAnalysisEnum;SurfaceSlopeAnalysisEnum;BedSlopeAnalysisEnum;ThermalAnalysisEnum;MeltingAnalysisEnum];
+
+	case ThermalSolutionEnum,
+		numanalyses=2; 
+		analyses=[ThermalAnalysisEnum;MeltingAnalysisEnum];
+
+	case EnthalpySolutionEnum,
+		numanalyses=1; 
+		analyses=[EnthalpyAnalysisEnum];
+
+	case PrognosticSolutionEnum,
+		numanalyses=1; 
+		analyses=[PrognosticAnalysisEnum];
+
+	case BalancethicknessSolutionEnum,
+		numanalyses=1; 
+		analyses=[BalancethicknessAnalysisEnum];
+
+	case SurfaceSlopeSolutionEnum,
+		numanalyses=1; 
+		analyses=[SurfaceSlopeAnalysisEnum];
+
+	case BedSlopeSolutionEnum,
+		numanalyses=1; 
+		analyses=[BedSlopeAnalysisEnum];
+
+	case TransientSolutionEnum,
+		numanalyses=9; 
+		analyses=[DiagnosticHorizAnalysisEnum;DiagnosticVertAnalysisEnum;DiagnosticHutterAnalysisEnum;SurfaceSlopeAnalysisEnum;BedSlopeAnalysisEnum;ThermalAnalysisEnum;MeltingAnalysisEnum;EnthalpyAnalysisEnum;PrognosticAnalysisEnum];
+
+	case FlaimSolutionEnum,
+		numanalyses=1; 
+		analyses=[FlaimAnalysisEnum];
+
+	case HydrologySolutionEnum,
+		numanalyses=3; 
+		analyses=[BedSlopeAnalysisEnum;SurfaceSlopeAnalysisEnum;HydrologyAnalysisEnum];
+
+	otherwise
+		error('%s%s%s',' solution type: ',EnumToString(solutiontype),' not supported yet!');
+
+end
Index: issm/branches/trunk-jpl-damage/src/m/model/MatlabProcessPatch.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/model/MatlabProcessPatch.m	(revision 12168)
+++ issm/branches/trunk-jpl-damage/src/m/model/MatlabProcessPatch.m	(revision 12168)
@@ -0,0 +1,65 @@
+function structure=MatlabProcessPatch(structure);
+%PROCESSPATCH - create a structure from a patch
+%
+%   Usage:
+%      Result=ProcessPatch(Result);
+
+%return if there is no fiel Patch
+if (~isfield(structure,'Patch')),
+	return;
+end
+
+%loop over steps
+for i=1:length(structure),
+
+	%Get Patch for current step
+	Patch=structure(i).Patch;
+	numvertices=structure(i).PatchVertices;
+
+	%check that Patch is not empty
+	if length(Patch)==0 continue; end
+
+	%Get number of fields;
+	fields=unique(Patch(:,1));
+	steps=unique(Patch(:,2));
+
+	%parse steps
+	for j=1:length(steps),
+
+		posstep=find(Patch(:,2)==steps(j));
+
+		%Take all the lines of the Patch for this timestep
+		temporarypatch=Patch(posstep,:);
+		time=temporarypatch(1,3);
+		step=temporarypatch(1,2);
+
+		%parse fields
+		for i=1:length(fields),
+
+			%get name
+			fieldname=EnumToString(fields(i));
+
+			%get line positions
+			pos=find(temporarypatch(:,1)==fields(i));
+
+			%Fill Result structure
+			structure(step).steps=step;
+			structure(step).time=time;
+			structure(step).(fieldname).element=temporarypatch(pos,4);
+			structure(step).(fieldname).interpolation=temporarypatch(pos,5);
+			structure(step).(fieldname).index=temporarypatch(pos,6:5+numvertices);
+			if structure(step).(fieldname).interpolation==P1Enum,
+				structure(step).(fieldname).value=temporarypatch(pos,6+numvertices:end);
+			end
+			if structure(step).(fieldname).interpolation==P0Enum,
+				structure(step).(fieldname).value=temporarypatch(pos,6+numvertices);
+			end
+
+		end
+	end
+end
+
+%remove fields
+structure=rmfield(structure,'Patch');
+structure=rmfield(structure,'PatchVertices');
+structure=rmfield(structure,'PatchNodes');
Index: issm/branches/trunk-jpl-damage/src/m/model/addnote.py
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/model/addnote.py	(revision 12168)
+++ issm/branches/trunk-jpl-damage/src/m/model/addnote.py	(revision 12168)
@@ -0,0 +1,29 @@
+def addnote(md, string):
+
+    # Local Variables: md, string, i, notes, miscellaneous, newnotes
+    # Function calls: ischar, nargout, cell, nargin, length, addnote, error
+    #ADDNOTE - add a note to the existing model notes field
+    #
+    #   Usage:
+    #      md=addnote(md,string);
+    #
+    #   Example:
+    #      md=addnote(md,'Pine Island, Geometry of 2007');
+    
+	if not isinstance(string,basetring):
+        print 'addnote error message: second input argument should be a string'
+		return []
+    
+    notes = md.miscellaneous.notes
+    
+	if isinstance(notes,basestring):
+		newnotes=[notes,string]
+    else:
+		newnotes=[];
+		for i in range(len(notes)):
+			newnotes=newnotes+notes[i]
+            
+        newnotes=newnotes+nodes;
+        
+    md.miscellaneous.notes = newnotes
+    return md
Index: issm/branches/trunk-jpl-damage/src/m/model/collapse.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/model/collapse.m	(revision 12167)
+++ issm/branches/trunk-jpl-damage/src/m/model/collapse.m	(revision 12168)
@@ -30,6 +30,6 @@
 if ~isnan(md.inversion.vel_obs), md.inversion.vel_obs=project2d(md,md.inversion.vel_obs,md.mesh.numberoflayers); end;
 if ~isnan(md.inversion.cost_functions_coefficients), md.inversion.cost_functions_coefficients=project2d(md,md.inversion.cost_functions_coefficients,md.mesh.numberoflayers); end;
-if ~isnan(md.inversion.min_parameters), md.inversion.min_parameters=project2d(md,md.inversion.min_parameters,md.mesh.numberoflayers); end;
-if ~isnan(md.inversion.max_parameters), md.inversion.max_parameters=project2d(md,md.inversion.max_parameters,md.mesh.numberoflayers); end;
+if numel(md.inversion.min_parameters)>1, md.inversion.min_parameters=project2d(md,md.inversion.min_parameters,md.mesh.numberoflayers); end;
+if numel(md.inversion.max_parameters)>1, md.inversion.max_parameters=project2d(md,md.inversion.max_parameters,md.mesh.numberoflayers); end;
 if ~isnan(md.surfaceforcings.mass_balance),
 	md.surfaceforcings.mass_balance=project2d(md,md.surfaceforcings.mass_balance,md.mesh.numberoflayers); 
@@ -102,6 +102,6 @@
 
 %lat long
-md.mesh.lat=project2d(md,md.mesh.lat,1);
-md.mesh.long=project2d(md,md.mesh.long,1);
+if numel(md.mesh.lat)>1,  md.mesh.lat=project2d(md,md.mesh.lat,1); end
+if numel(md.mesh.long)>1, md.mesh.long=project2d(md,md.mesh.long,1); end
 
 %Initialize with the 2d mesh
Index: issm/branches/trunk-jpl-damage/src/m/model/mesh/triangle.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/model/mesh/triangle.m	(revision 12167)
+++ issm/branches/trunk-jpl-damage/src/m/model/mesh/triangle.m	(revision 12168)
@@ -38,33 +38,30 @@
 
 %Mesh using TriMesh
-if strcmp(riftname,''),
-	[md.mesh.elements,md.mesh.x,md.mesh.y,md.mesh.segments,md.mesh.segmentmarkers]=TriMesh(domainname,area,true);
-else
-	[elements,x,y,segments,segmentmarkers]=TriMeshRifts(domainname,riftname,area,'yes');
+[elements,x,y,segments,segmentmarkers]=TriMesh(domainname,riftname,area);
 
-	%check that all the created nodes belong to at least one element
-	orphan=find(~ismember([1:length(x)],sort(unique(elements(:)))));
-	for i=1:length(orphan),
-		%get rid of the orphan node i
-		%update x and y
-		x=[x(1:orphan(i)-(i-1)-1); x(orphan(i)-(i-1)+1:end)];
-		y=[y(1:orphan(i)-(i-1)-1); y(orphan(i)-(i-1)+1:end)];
-		%update elements
-		pos=find(elements>orphan(i)-(i-1));
-		elements(pos)=elements(pos)-1;
-		%update segments
-		pos1=find(segments(:,1)>orphan(i)-(i-1));
-		pos2=find(segments(:,2)>orphan(i)-(i-1));
-		segments(pos1,1)=segments(pos1,1)-1;
-		segments(pos2,2)=segments(pos2,2)-1;
-	end
+%check that all the created nodes belong to at least one element
+orphan=find(~ismember([1:length(x)],sort(unique(elements(:)))));
+for i=1:length(orphan),
+	disp('WARNING: removing orphans');
+	%get rid of the orphan node i
+	%update x and y
+	x=[x(1:orphan(i)-(i-1)-1); x(orphan(i)-(i-1)+1:end)];
+	y=[y(1:orphan(i)-(i-1)-1); y(orphan(i)-(i-1)+1:end)];
+	%update elements
+	pos=find(elements>orphan(i)-(i-1));
+	elements(pos)=elements(pos)-1;
+	%update segments
+	pos1=find(segments(:,1)>orphan(i)-(i-1));
+	pos2=find(segments(:,2)>orphan(i)-(i-1));
+	segments(pos1,1)=segments(pos1,1)-1;
+	segments(pos2,2)=segments(pos2,2)-1;
+end
 
-	%plug into md
-	md.mesh.x=x;
-	md.mesh.y=y;
-	md.mesh.elements=elements;
-	md.mesh.segments=segments;
-	md.mesh.segmentmarkers=segmentmarkers;
-end
+%plug into md
+md.mesh.x=x;
+md.mesh.y=y;
+md.mesh.elements=elements;
+md.mesh.segments=segments;
+md.mesh.segmentmarkers=segmentmarkers;
 
 %Fill in rest of fields:
Index: issm/branches/trunk-jpl-damage/src/m/model/mesh/triangle.py
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/model/mesh/triangle.py	(revision 12168)
+++ issm/branches/trunk-jpl-damage/src/m/model/mesh/triangle.py	(revision 12168)
@@ -0,0 +1,56 @@
+from numpy import *
+import TriMesh as tm
+import NodeConnectivity as nc
+import ElementConnectivity as ec
+
+def triangle(md, domainname, resolution,riftname=''):
+	#TRIANGLE - create model mesh using the triangle package
+	#
+	#   This routine creates a model mesh using TriMesh and a domain outline, to within a certain resolution
+	#   where md is a @model object, domainname is the name of an Argus domain outline file, 
+	#   and resolution is a characteristic length for the mesh (same unit as the domain outline
+	#   unit). Riftname is an optional argument (Argus domain outline) describing rifts.
+	#
+	#   Usage:
+	#      md=triangle(md,domainname,resolution)
+	#   or md=triangle(md,domainname, resolution, riftname)
+	#
+	#   Examples:
+	#      md=triangle(md,'DomainOutline.exp',1000);
+	#      md=triangle(md,'DomainOutline.exp',1000,'Rifts.exp');
+
+
+	#Figure out a characteristic area. Resolution is a node oriented concept (ex a 1000m  resolution node would 
+	#be made of 1000*1000 area squares). 
+
+	#Check that mesh was not already run, and warn user: 
+	if md.mesh.numberofelements != 0.:
+		choice = input('This model already has a mesh. Are you sure you want to go ahead? (y/n)')
+		if choice != 'y':
+			print 'no meshing done ... exiting'
+			return []
+		
+	area = resolution**2.
+
+	#Mesh using TriMesh
+	[md.mesh.elements,md.mesh.x,md.mesh.y,md.mesh.segments,md.mesh.segmentmarkers]=tm.TriMesh(domainname,riftname,area)
+
+
+	#Fill in rest of fields:
+	md.mesh.numberofelements = len(md.mesh.elements)
+	md.mesh.numberofvertices = len(md.mesh.x)
+	md.mesh.z = zeros(md.mesh.numberofvertices)
+	md.mesh.vertexonboundary = zeros(md.mesh.numberofvertices)
+	md.mesh.vertexonboundary[md.mesh.segments[:,0:2].astype(int)-1] = 1.
+	md.mesh.vertexonbed = ones(md.mesh.numberofvertices)
+	md.mesh.vertexonsurface = ones(md.mesh.numberofvertices)
+	md.mesh.elementonbed = ones(md.mesh.numberofelements)
+	md.mesh.elementonsurface = ones(md.mesh.numberofelements)
+
+	#Now, build the connectivity tables for this mesh.
+	[md.mesh.vertexconnectivity]= nc.NodeConnectivity(md.mesh.elements, md.mesh.numberofvertices)
+	[md.mesh.elementconnectivity] = ec.ElementConnectivity(md.mesh.elements, md.mesh.vertexconnectivity)
+	
+	#type of model
+	md.mesh.dimension = 2.
+	return md
Index: issm/branches/trunk-jpl-damage/src/m/model/modis.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/model/modis.m	(revision 12167)
+++ issm/branches/trunk-jpl-damage/src/m/model/modis.m	(revision 12168)
@@ -14,9 +14,9 @@
 
 %Get path  to gdal binaries
-path_gdal=[issmtier() '/externalpackages/gdal/install/bin/'];
+path_gdal=[issmdir() '/externalpackages/gdal/install/bin/'];
 
 %Was gdal compiled? 
 if ~exist([path_gdal 'gdal_translate']),
-	error(['modis error message: GDAL library needs to be compiled to use this routine. Compile GDAL in ' issmtier() '/externalpackages/gdal to use this routine.']);
+	error(['modis error message: GDAL library needs to be compiled to use this routine. Compile GDAL in ' issmdir() '/externalpackages/gdal to use this routine.']);
 end
 
Index: issm/branches/trunk-jpl-damage/src/m/model/parameterization/parameterize.py
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/model/parameterization/parameterize.py	(revision 12168)
+++ issm/branches/trunk-jpl-damage/src/m/model/parameterization/parameterize.py	(revision 12168)
@@ -0,0 +1,27 @@
+import os
+def  parameterize(md,parametername):
+	#PARAMETERIZE - parameterize a model
+	#
+	#   from a parameter matlab file, start filling in all the model fields that were not 
+	#   filled in by the mesh.py and setmask.py model methods.
+	#   Warning: the parameter file must be able to be run in Python
+	#
+	#   Usage:
+	#      md=parameterize(md,parametername)
+	#
+	#   Example:
+	#      md=parameterize(md,'Square.par');
+
+	#some checks
+	if not os.path.isfile(parametername):
+		print 'parameterize error message: file '+parametername+' not found.'
+		return []
+
+	#Try and run parameter file.
+	execfile(parametername)
+	
+	#ame and notes
+	if len(md.miscellaneous.name)==0:
+		md.miscellaneous.name=os.path.basename(parametername)
+	
+	md=addnote(md,'Model created by using parameter file: '+parametername+' on: '+str(datetime.datetime.now()))
Index: issm/branches/trunk-jpl-damage/src/m/model/petscversion.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/model/petscversion.m	(revision 12167)
+++ issm/branches/trunk-jpl-damage/src/m/model/petscversion.m	(revision 12168)
@@ -8,5 +8,5 @@
 PETSC_VERSION=3;
 
-configfile=[issmtier() '/config.h'];
+configfile=[issmdir() '/config.h'];
 if ~exist(configfile,'file'),
 	error(['File ' configfile ' not found. ISSM has not been configured yet!']);
Index: issm/branches/trunk-jpl-damage/src/m/model/plot/applyoptions.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/model/plot/applyoptions.m	(revision 12167)
+++ issm/branches/trunk-jpl-damage/src/m/model/plot/applyoptions.m	(revision 12168)
@@ -229,4 +229,7 @@
 		warning on MATLAB:log:logOfZero;
 		set(c,'YTickLabel',labels);
+	end 
+ 	if exist(options,'cbYLim'); 
+		set(c,'YLim',getfieldvalue(options,'cbYLim'));
 	end
 	if exist(options,'colorbartitle'),
Index: issm/branches/trunk-jpl-damage/src/m/model/plot/northarrow.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/model/plot/northarrow.m	(revision 12167)
+++ issm/branches/trunk-jpl-damage/src/m/model/plot/northarrow.m	(revision 12168)
@@ -72,5 +72,5 @@
 
 %Text North
-xN=max([A(1) D(1) E(1) F(1) G(1)])+ratio/3*lengtharrow;
+xN=max([A(1) D(1) E(1) F(1) G(1)])+ratio/3*abs(lengtharrow);
 yN=mean([A(2) F(2) H(2)]);
 text(xN,yN,'North','FontSize',fontsize,'FontWeight','b');
Index: issm/branches/trunk-jpl-damage/src/m/model/plot/plot_gridded.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/model/plot/plot_gridded.m	(revision 12167)
+++ issm/branches/trunk-jpl-damage/src/m/model/plot/plot_gridded.m	(revision 12168)
@@ -40,4 +40,5 @@
 	data_max=max(data_grid(:));
 end
+options=changefieldvalue(options,'cbYLim',[data_min data_max]);
 if whitepos==1,
 	white  =data_max + (data_max-data_min)/55;
Index: issm/branches/trunk-jpl-damage/src/m/model/plot/plot_overlay.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/model/plot/plot_overlay.m	(revision 12167)
+++ issm/branches/trunk-jpl-damage/src/m/model/plot/plot_overlay.m	(revision 12168)
@@ -96,5 +96,5 @@
 	%h_data(find(data_grid>data_mean))=1;
 	h_data=1*ones(size(data_grid));
-	h_data(find(data_grid>data_mean))=0.7;
+	h_data(find(data_grid<data_mean))=0.7;
 	%saturation (S)
 	s_data=max(min(abs(data_grid-data_mean)/(data_max-data_mean) ,1),0);
Index: issm/branches/trunk-jpl-damage/src/m/model/plot/plot_section.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/model/plot/plot_section.m	(revision 12167)
+++ issm/branches/trunk-jpl-damage/src/m/model/plot/plot_section.m	(revision 12168)
@@ -36,5 +36,5 @@
 
 %read contours: 
-profiles=expread(getfieldvalue(options,'sectionvalue'),1);
+profiles=expread(getfieldvalue(options,'sectionvalue'));
 numprofiles=length(profiles);
 
Index: issm/branches/trunk-jpl-damage/src/m/model/setmask.py
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/model/setmask.py	(revision 12168)
+++ issm/branches/trunk-jpl-damage/src/m/model/setmask.py	(revision 12168)
@@ -0,0 +1,55 @@
+from numpy import *
+import FlagElements as fe
+
+def setmask(md, floatingicename, groundedicename):
+	#SETMASK - establish boundaries between grounded and floating ice.
+	#
+	#   By default, ice is considered grounded. The contour floatingicename defines nodes 
+	#   for which ice is floating. The contour groundedicename defines nodes inside an floatingice, 
+	#   that are grounded (ie: ice rises, islands, etc ...)
+	#   All input files are in the Argus format (extension .exp).
+	#
+	#   Usage:
+	#      md=setmask(md,floatingicename,groundedicename)
+	#
+	#   Examples:
+	#      md=setmask(md,'all','');
+	#      md=setmask(md,'Iceshelves.exp','Islands.exp');
+
+	#%Get assigned fields
+	x = md.mesh.x
+	y = md.mesh.y
+	elements = md.mesh.elements
+
+	#Assign elementonfloatingice, elementongroundedice, vertexongroundedice and vertexonfloatingice. Only change at your own peril! This is synchronized heavily with the GroundingLineMigration module. {{{1
+	elementonfloatingice = fe.FlagElements(md, floatingicename)
+	elementongroundedice = fe.FlagElements(md, groundedicename) 
+
+	#Because groundedice nodes and elements can be included into an floatingice, we need to update. Remember, all the previous 
+	#arrays come from domain outlines that can intersect one another: 
+
+	elementonfloatingice = logical_and(elementonfloatingice,~elementongroundedice)
+	elementongroundedice = ~elementonfloatingice
+
+	#the order here is important. we choose vertexongroundedice as default on the grounding line.
+	vertexonfloatingice = zeros(md.mesh.numberofvertices,'bool')
+	vertexongroundedice = zeros(md.mesh.numberofvertices,'bool')
+
+	pos=argwhere(elementongroundedice==1)
+	pos=md.mesh.elements[pos,:]-1
+	if pos.size:
+		vertexongroundedice[pos]=True
+
+	pos=argwhere(~vertexongroundedice)
+	if pos.size:
+		vertexonfloatingice[pos]=True;
+	#%}}}
+
+	#Return: 
+	md.mask.elementonfloatingice = double(elementonfloatingice)
+	md.mask.vertexonfloatingice = double(vertexonfloatingice)
+	md.mask.elementongroundedice = double(elementongroundedice)
+	md.mask.vertexongroundedice = double(vertexongroundedice)
+	md.mask.vertexonwater = zeros(md.mesh.numberofvertices)
+	md.mask.elementonwater = zeros(md.mesh.numberofelements)
+	return md
Index: issm/branches/trunk-jpl-damage/src/m/utils/BC/SetIceShelfBC.py
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/utils/BC/SetIceShelfBC.py	(revision 12168)
+++ issm/branches/trunk-jpl-damage/src/m/utils/BC/SetIceShelfBC.py	(revision 12168)
@@ -0,0 +1,93 @@
+def SetIceShelfBC(md,icefrontfile='')
+	#SETICESHELFBC - Create the boundary conditions for diagnostic and thermal models for a  Ice Shelf with Ice Front
+	#
+	#   Neumann BC are used on the ice front (an ANRGUS contour around the ice front
+	#   must be given in input)
+	#   Dirichlet BC are used elsewhere for diagnostic
+	#
+	#   Usage:
+	#      md=SetIceShelfBC(md,varargin)
+	#
+	#   Example:
+	#      md=SetIceShelfBC(md);
+	#      md=SetIceShelfBC(md,'Front.exp');
+	#
+	#   See also: SETICESHEETBC, SETMARINEICESHEETBC
+
+	#node on Dirichlet (boundary and ~icefront)
+	if not icefrontfile:
+		nodeonicefront=zeros(md.mesh.numberofvertices)
+	else:
+		if not os.path.isfile(icefrontfile):
+			print 'SetIceShelfBC error message: ice front file '+icefrontfile+ ' not found'
+			return []
+		nodeinsideicefront=ContourToMesh(md.mesh.elements,md.mesh.x,md.mesh.y,icefrontfile,'node',2);
+		nodeonicefront=double(md.mesh.vertexonboundary & nodeinsideicefront);
+	
+	pos=find(md.mesh.vertexonboundary & ~nodeonicefront);
+	md.diagnostic.spcvx=NaN*ones(md.mesh.numberofvertices,1);
+	md.diagnostic.spcvy=NaN*ones(md.mesh.numberofvertices,1);
+	md.diagnostic.spcvz=NaN*ones(md.mesh.numberofvertices,1);
+	md.diagnostic.spcvx(pos)=0;
+	md.diagnostic.spcvy(pos)=0;
+	md.diagnostic.spcvz(pos)=0;
+	md.diagnostic.referential=NaN*ones(md.mesh.numberofvertices,6);
+
+	#Dirichlet Values
+	if (length(md.inversion.vx_obs)==md.mesh.numberofvertices & length(md.inversion.vy_obs)==md.mesh.numberofvertices)
+		disp('      boundary conditions for diagnostic model: spc set as observed velocities');
+		md.diagnostic.spcvx(pos)=md.inversion.vx_obs(pos);
+		md.diagnostic.spcvy(pos)=md.inversion.vy_obs(pos);
+	else
+		disp('      boundary conditions for diagnostic model: spc set as zero');
+	end
+
+	#segment on Ice Front
+	#segment on Neumann (Ice Front)
+	pos=find(nodeonicefront(md.mesh.segments(:,1)) | nodeonicefront(md.mesh.segments(:,2)));
+	if (md.mesh.dimension==2)
+		pressureload=md.mesh.segments(pos,:);
+	elseif md.mesh.dimension==3
+		pressureload_layer1=[md.mesh.segments(pos,1:2)  md.mesh.segments(pos,2)+md.mesh.numberofvertices2d  md.mesh.segments(pos,1)+md.mesh.numberofvertices2d  md.mesh.segments(pos,3)];
+		pressureload=[];
+		for i=1:md.mesh.numberoflayers-1,
+			pressureload=[pressureload ;pressureload_layer1(:,1:4)+(i-1)*md.mesh.numberofvertices2d pressureload_layer1(:,5)+(i-1)*md.mesh.numberofelements2d ];
+		end
+	end
+
+	#Add water or air enum depending on the element
+	pressureload=[pressureload 1*md.mask.elementonfloatingice(pressureload(:,end))];
+
+	#plug onto model
+	md.diagnostic.icefront=pressureload;
+
+	#Create zeros basalforcings and surfaceforcings
+	if isnan(md.surfaceforcings.precipitation),
+		md.surfaceforcings.precipitation=zeros(md.mesh.numberofvertices,1);
+		disp('      no surfaceforcings.precipitation specified: values set as zero');
+	end
+	if isnan(md.surfaceforcings.mass_balance),
+		md.surfaceforcings.mass_balance=zeros(md.mesh.numberofvertices,1);
+		disp('      no surfaceforcings.mass_balance specified: values set as zero');
+	end
+	if isnan(md.basalforcings.melting_rate),
+		md.basalforcings.melting_rate=zeros(md.mesh.numberofvertices,1);
+		disp('      no basalforcings.melting_rate specified: values set as zero');
+	end
+	if isnan(md.balancethickness.thickening_rate),
+		md.balancethickness.thickening_rate=zeros(md.mesh.numberofvertices,1);
+		disp('      no balancethickness.thickening_rate specified: values set as zero');
+	end
+
+	md.prognostic.spcthickness=NaN*ones(md.mesh.numberofvertices,1);
+	md.balancethickness.spcthickness=NaN*ones(md.mesh.numberofvertices,1);
+
+	if (length(md.initialization.temperature)==md.mesh.numberofvertices),
+		md.thermal.spctemperature=NaN*ones(md.mesh.numberofvertices,1);
+		pos=find(md.mesh.vertexonsurface); md.thermal.spctemperature(pos)=md.initialization.temperature(pos); #impose observed temperature on surface
+		if (length(md.basalforcings.geothermalflux)~=md.mesh.numberofvertices),
+			md.basalforcings.geothermalflux=zeros(md.mesh.numberofvertices,1);
+		end
+	else
+		disp('      no thermal boundary conditions created: no observed temperature found');
+	end
Index: issm/branches/trunk-jpl-damage/src/m/utils/DataProcessing/TracksToMatrix.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/utils/DataProcessing/TracksToMatrix.m	(revision 12167)
+++ issm/branches/trunk-jpl-damage/src/m/utils/DataProcessing/TracksToMatrix.m	(revision 12168)
@@ -26,5 +26,5 @@
 
 %Add path to dace
-addpath([issmtier() '/externalpackages/dace/install'])
+addpath([issmdir() '/externalpackages/dace/install'])
 
 %First create the x_m and y_m fot the matrix
@@ -82,3 +82,3 @@
 
 %remove DACE path
-rmpath([issmtier() '/externalpackages/dace/install']);
+rmpath([issmdir() '/externalpackages/dace/install']);
Index: issm/branches/trunk-jpl-damage/src/m/utils/Exp/expdisp.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/utils/Exp/expdisp.m	(revision 12167)
+++ issm/branches/trunk-jpl-damage/src/m/utils/Exp/expdisp.m	(revision 12168)
@@ -41,5 +41,5 @@
 end
 
-domain=expread(domainoutline,1);
+domain=expread(domainoutline);
 
 figure(figurenumber),hold on
Index: issm/branches/trunk-jpl-damage/src/m/utils/Exp/exptool.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/utils/Exp/exptool.m	(revision 12167)
+++ issm/branches/trunk-jpl-damage/src/m/utils/Exp/exptool.m	(revision 12168)
@@ -71,5 +71,5 @@
 		else
 			%read file
-			B=expread(filename,1);
+			B=expread(filename);
 			%go through all profiles of B
 			for i=1:size(B,2)
Index: issm/branches/trunk-jpl-damage/src/m/utils/Geometry/FlagElements.py
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/utils/Geometry/FlagElements.py	(revision 12168)
+++ issm/branches/trunk-jpl-damage/src/m/utils/Geometry/FlagElements.py	(revision 12168)
@@ -0,0 +1,54 @@
+from numpy import * 
+def FlagElements(md,region):
+#FLAGELEMENTS - flag the elements in an region
+#
+#   The region can be given with an exp file, a list of elements.
+#
+#   Usage: 
+#      flag=FlagElements(md,region);
+#
+#   Example:
+#      flag=FlagElements(md,'all');
+#      flag=FlagElements(md,'');
+#      flag=FlagElements(md,'Domain.exp');
+#      flag=FlagElements(md,'~Domain.exp');
+#      flag=FlagElements(md,md.mask.elementongroundedice);
+
+	if isinstance(region,basestring):
+		if not(region):
+			flag=zeros(md.mesh.numberofelements,'bool')
+			invert=0;
+		elif region=='all':
+			flag=ones(md.mesh.numberofelements,'bool')
+			invert=0;
+		else:
+			#make sure that we actually don't want the elements outside the domain outline!
+			if region[0]=='~':
+				region=region[1:]
+				invert=1;
+			else:
+				invert=0;
+			
+			#does the region domain outline exist or do we have to look for xlim,ylim in basinzoom?
+			if not os.path.isfile(region):
+				[xlim,ylim]=basinzoom('basin',region);
+				flag_nodes=double(md.mesh.x<xlim(2) & md.mesh.x>xlim(1) &  md.mesh.y<ylim(2) & md.mesh.y>ylim(1));
+				flag=prod(flag_nodes(md.mesh.elements),2);
+			else:
+				#ok, flag elements
+				flag=ContourToMesh(md.mesh.elements[:,0:3],md.mesh.x,md.mesh.y,region,'element',1);
+		
+		if invert:
+			flag=~flag;
+	
+	elif isinstance(region,nparray):
+		if len(region)!=md.mesh.numberofelements:
+			print FlagElements.__doc__
+			print 'Flaglist for region must be of same size as number of elements in model'
+			return []
+		flag=region;
+	else:
+		print 'Invalid region option'
+		return []
+
+	return flag;
